package de.intevation.gnv.math;

import java.util.Map;
import java.util.HashMap;
import java.util.List;

import java.io.Serializable;

import de.intevation.gnv.jfreechart.PolygonDataset; 

/**
 *  @author Ingo Weinzierl      (ingo.weinzierl@intevation.de)
 *  @author Sascha L. Teichmann (sascha.teichmann@intevation.de)
 */
public class AttributedXYColumns
implements   Serializable
{
    protected List<? extends XYColumn> columns;
    protected Map                      attributes;
    protected Interpolation3D          interpolation;
    protected PolygonDataset           dataset;

    public AttributedXYColumns() {
    }

    public AttributedXYColumns(List<? extends XYColumn> columns) {
        this(columns, null);
    }

    public AttributedXYColumns(List<? extends XYColumn> columns, Map attributes) {
        this.columns    = columns;
        this.attributes = attributes;
    }

    public Object getAttribute(Object key) {
        return attributes != null
            ? attributes.get(key)
            : null;
    }

    public void setAttribute(Object key, Object value) {
        if (attributes == null) {
            attributes = new HashMap();
        }
        attributes.put(key, value);
    }

    public List<? extends XYColumn> getXYColumns() {
        return columns;
    }

    public void setXYColumns(List<? extends XYColumn> columns) {
        this.columns = columns;
    }

    public void setInterpolation(Interpolation3D interpolation) {
        this.interpolation = interpolation;
    }

    public Interpolation3D getInterpolation() {
        return interpolation;
    }

    public void setPolygonDataset(PolygonDataset dataset) {
        this.dataset = dataset;
    }

    public PolygonDataset getPolygonDataset() {
        return dataset;
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf8:
